#!/usr/bin/perl

# Internet Gateway Control Panel
# Copyright (c) 2542 (1999) by Atsawin Chowanakritsanakul

use CGI;

require 'getmsg.pl';

getmsg();

$fifo = "/usr/lib/diald/diald.fifo";
$stat = "/usr/lib/diald/diald.stat";

if (!fork)
{
  select(undef, undef, undef, 0.05);   # Wait 50 ms

  open(FIFO, "> $fifo") or die $!;
  print FIFO "monitor 0x00000105 $stat\n";
  close(FIFO);

  exit(0);
}

open(STAT, "< $stat") or die $!;
do
{
  $text = <STAT>;
  $state1 = <STAT>;
  chomp($text);
} until ($text eq 'STATE');
do
{
  $text = <STAT>;
  $state2 = <STAT>;
  chomp($text);
} until ($text eq 'STATUS');
close(STAT);

chomp($state1);
chomp($state2);

$connection_old = ($state1 eq 'DOWN') ? 'DOWN' : 'UP';
@state2 = split(/ /, $state2);
$connection_mode = (($state2[10] eq '0') && ($state2[11] eq '0')) ? 'auto' : 'manual';

$r = new CGI;

$cmd = $r->param('cmd');

if ($cmd ne $connection_old)
{
  open(FIFO, "> $fifo") or die $!;
  print FIFO ($cmd eq 'UP') ?
    ($connection_mode eq 'auto') ?
      "up\n"
    :
      "unblock\nforce\nup\n"
  :
    ($connection_mode eq 'auto') ?
      "down\n"
    :
      "unforce\nblock\ndown\n";
  close(FIFO);
}

# HTTP protocol header
print $r->header;

print <<EOM;
<html>
<head>
<title>$msg{'global.Internet Gateway Control Panel'} : $msg{'global.Main Menu'} : $msg{'Control Changed'}</title>
<link rel=stylesheet type="text/css" href="/gateway/default.css">
</head>
<body bgcolor=#ffffff text=#000000 link=#0000ff vlink=#0000ff alink=#ff0000>
<table border=0 cellspacing=0 cellpadding=2 width=100%>
<tr>
<td bgcolor=#99cccc width=100%>
<a href="/gateway/intro.html" target="f1">$msg{'global.Internet Gateway Control Panel'}</a> :
<a href="/gateway/main.html" target="f1">$msg{'global.Main Menu'}</a>
</td>
</tr>
<tr>
<td bgcolor=#ccffff width=100% align=center>
<font size=+3>$msg{'control.Control Changed'}</font>
</td>
</tr>
</table>
<p>

<table border=2 cellspacing=2 cellpadding=2 align=center>
<tr>
<td bgcolor=#ccffff align=right>
$msg{'control.Command'}</td>
<td bgcolor=#ffffcc>
$msg{'control.' . $cmd}
</td>
</tr>
<tr>
<td bgcolor=#ccffcc align=center colspan=2>
<a href="/gateway/main.html" target="f1">$msg{'global.Back to Main Menu'}</a>
</td>
</tr>
</table>

</body>
</html>
EOM

