#!/usr/bin/perl -T

# htpasswd.cgi by David Efflandt (efflandt@xnet.com) 8/97
# Last update 10/4/99

# Edited for Internet Gateway Control Panel
# By Atsawin Chowanakritsanakul

### Variables

# Password file with full system path (where not accessible by URL).
$file = '/usr/local/apache/share/gateway.pwd';

# Allow anyone to add new users (1 = yes, 0 = no)
$allow_new = 0;

# Set untainted path for suid scripts
$ENV{PATH} = '/bin:/usr/bin:/usr/local/bin';
$ENV{IFS} = "" if $ENV{IFS} ne "";

### End of Variables

# Create form and exit on GET
&make_form unless ($ENV{'REQUEST_METHOD'} eq "POST");

# Get POST input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
  ($name, $value) = split(/=/, $pair);

  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $name =~ tr/+/ /;
  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

  $FORM{$name} = $value;
}

if ($FORM{user}) {
  $user = $FORM{user};
} else {
  &error("Error", "Username missing from form.");
}
$pwd = $FORM{old};
$command = $FORM{command};
unless (($command eq 'remove')
    ||($FORM{new} && $FORM{new} eq $FORM{new2})) {
  &error("Password Mismatch", "New password mismatch or missing.");
}

# Get existing passwords
if (-e $file) {
  open (IN, $file) or &error("Error", "Can't open password file: $!");
  flock(IN,2);
  seek(IN,0,0);
  while (<IN>) {
    chomp;
    ($name, $value, $tail) = split(/:/, $_, 3);
    $hash{$name} = $value;
    $tail{$name} = $tail;	# maintain any additional fields
  }
  close IN;
}

# Salt for crypt
@range = ('0'..'9','a'..'z','A'..'Z','.','/');
srand ( time() ^ ($$ + ($$ << 15)) );
$salt = $range[rand(int($#range)+1)] . $range[rand(int($#range)+1)];

# Check for valid password or existing user
$pass = $hash{$user} if $hash{$user};
$cpwd = crypt($pwd, $pass);
$admin = $hash{admin} && crypt($pwd, $hash{admin}) eq $hash{admin};

if (($command ne 'new') && ($admin || $pass && $cpwd eq $pass)) {
  if ($command eq 'remove') {
    delete($hash{$user}); delete($tail{$user});
    $msg = "User <B>$user</B> was removed from password file.";
  } elsif (!$pass) {
    $msg = "WARNING! 'Change Password' checked for non-existing user?\n"
    . "<P>Assigning password for new user <B>$user</B> anyway.\n"
    . "<P>If this was an error, go back and 'Remove User'";
  } else {
    $msg = "Password has been updated for $user.";
  }
} elsif ($FORM{command} eq 'new') {
  if ($pass) {
    &error("Sorry", "User <B>$user</B> is already assigned.");
  }elsif ($allow_new || $admin) {
    $msg = "Password has been assigned for new user $user.";
  } else {
    &begin_html("Sorry, New User");
    print "Contact file owner for password you can change later.";
    &end_html;
    exit;
  }
} else {
  &error("Password Error", 
    "Invalid user or password.");
}

# Assign new password to user and write to file
$hash{$user} = crypt($FORM{new}, $salt) if $command ne 'remove';
if (open(OUT, ">$file")) {
  flock(OUT,2);
  seek(OUT,0,0);
  foreach $name (sort keys %hash) {
    print OUT "$name:$hash{$name}";
    print OUT ":$tail{$name}" if $tail{$name};
    print OUT "\n";
  }
} else {
  &error("Error","Can't update password file: $!");
}

# Print Return HTML
print "Content-type: text/html\n\n";

print <<EOM;
<html>
<head>
<title>Internet Gateway Control Panel : Main Menu : Password Changed</title>
</head>
<body bgcolor=#ffffff text=#000000 link=#0000ff vlink=#990099 alink=#ff0000>
<table border=0 cellspacing=0 cellpadding=2 width=100%>
<tr>
<td bgcolor=#99cccc width=100%>
<a href="/gateway/intro.html">Internet Gateway Control Panel</a> :
<a href="/gateway/main.html">Main Menu</a>
</td>
</tr>
<tr>
<td bgcolor=#ccffff width=100% align=center>
<font size=+3>Password Changed</font>
</td>
</tr>
</table>
<p>
<table border=2 cellspacing=2 cellpadding=2 align=center>
<tr>
<td bgcolor=#ccffff align=center colspan=2>
<a href="/gateway/main.html">Back to Main Menu</a>
</td>
</tr>
</table>
<p>
</body>
</html>
EOM

### Subroutines

#subroutine begin_html(title)
sub begin_html {
  local ($title) = @_;
  print "Content-type: text/html\n\n";
  print "<html><head><title>$title</title></head><body>\n";
  print "<center><h1>$title</h1></center>\n<hr><p>\n";
}

#subroutine end_html
sub end_html {
# Add footer links here
  print "<P></body></html>\n";
}

#subroutine make_form
sub make_form {
#  &begin_html("Change Password");

print "Content-type: text/html\n\n";
print <<EOM;

<html>
<head>
<title>Internet Gateway Control Panel : Main Menu : Change Password</title>
</head>
<body bgcolor=#ffffff text=#000000 link=#0000ff vlink=#990099 alink=#ff0000>
<table border=0 cellspacing=0 cellpadding=2 width=100%>
<tr>
<td bgcolor=#99cccc width=100%>
<a href="/gateway/intro.html">Internet Gateway Control Panel :</a>
<a href="/gateway/main.html">Main Menu</a>
</td>
</tr>
<tr>
<td bgcolor=#ccffff width=100% align=center>
<font size=+3>Change Password</font>
</td>
</tr>
</table>
<p>

<form method=post action="$ENV{SCRIPT_NAME}">
<input type=hidden name="command" value="change">
<table border=2 cellspacing=2 cellpadding=2 align=center>
<tr>
<td bgcolor=#ffffcc align=right>Username</td>
<td><input name="user" size=15 maxlength=15></td>
</tr>
<tr>
<td bgcolor=#ffffcc align=right>Current Password</td>
<td><input type=password name="old" size=8 maxlength=8></td>
</tr>
<tr>
<td bgcolor=#ffffcc align=right>New Password</td>
<td><input type=password name="new" size=8 maxlength=8></td>
</tr>
<tr>
<td bgcolor=#ffffcc align=right>Retype Password</td>
<td><input type=password name="new2" size=8 maxlength=8></td>
</tr>
<tr>
<td bgcolor=#ccffff align=center colspan=3>
<input type=submit value="OK">
<input type=reset value="Undo">
</td>
</tr>
</table>
</form>

</body>
</html>
EOM

  exit;
}

sub error {
  local($title,$msg) = @_;
  &begin_html($title);
  print "<P>$msg\n";
  print "<P>Please check your name and re-enter passwords.\n";
  print "<p>Please press <b>Back</b> button.\n";
  &end_html;
  exit;
}
