#!/usr/bin/perl

# Internet Gateway Control Panel
# Copyright (c) 2542 (1999) by Atsawin Chowanakritsanakul

use CGI;
use Time::Local;

require 'getmsg.pl';

getmsg();

$conf = "/usr/lib/diald/conf/dialdcpl.conf";
$history = "/usr/lib/diald/history.txt";

$r = new CGI;

open(TEXT, "$conf") or die $!;
@text = <TEXT>;
close(TEXT);

$section = 1000;
foreach $line (@text)
{
  chomp($line);
  if (substr($line, 0, 5) eq '[conf')
  { 
    $section = substr($line, 5, 1);
  }
  else
  { 
    ($key, $value) = split(/=/, $line, 2);
    if ($section < 1000)
    { 
      $key = $section . $key;
    }
    $param{$key} = $value;
  }
}

$conf_sel = "";
for ($conf = 0; $conf < 10; $conf++)
{
  if ($r->param('config' . $conf))
  {
    $conf_sel .= $conf;
  }
}

$fdate = $r->param('fdate');
$fmonth = $r->param('fmonth');
$fyear = $r->param('fyear');
$tdate = $r->param('tdate');
$tmonth = $r->param('tmonth');
$tyear = $r->param('tyear');
$ftime = timelocal(0, 0, 0, $fdate, $fmonth, $fyear);
$ttime = timelocal(0, 0, 0, $tdate, $tmonth, $tyear)+3599;

# HTTP protocol header
print $r->header;

open(TEXT, "$history") or die $!;
@text = <TEXT>;
close(TEXT);

print <<EOM;
<html>
<head>
<title>$msg{'global.Internet Gateway Control Panel'} : $msg{'global.Main Menu'} : $msg{'Control Changed'}</title>
<link rel=stylesheet type="text/css" href="/gateway/default.css">
</head>
<body bgcolor=#ffffff text=#000000 link=#0000ff vlink=#0000ff alink=#ff0000>
<table border=0 cellspacing=0 cellpadding=2 width=100%>
<tr>
<td bgcolor=#99cccc width=100%>
<a href="/gateway/intro.html" target="f1">$msg{'global.Internet Gateway Control Panel'}</a> :
<a href="/gateway/main.html" target="f1">$msg{'global.Main Menu'}</a>
</td>
</tr>
<tr>
<td bgcolor=#ccffff width=100% align=center>
<font size=+3>$msg{'global.Report'}</font>
</td>
</tr>
</table>
<p>

<table border=2 cellspacing=2 cellpadding=2 align=center>
<tr>
<td bgcolor="#ccccff" align="center">$msg{'report.No'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Date/Time'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Config'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Phone'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Speed'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Connection'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.End'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Duration'}</td>
</tr>
EOM

$cnt = 0;
$isp = -1;
foreach $line (@text)
{
  chomp($line);
  @line = split(/ +/, $line);
  if ($line[0] >= $ftime && $line[0] <= $ttime)
  {
    if ($line[1] eq 'DI')
    {
      if ($isp >= 0)
      {
        print "</tr>\n";
      }
      $isp = $line[2];
    }
    if (index($conf_sel, $isp) >= 0)
    {
      if ($line[1] eq 'DI')
      {
        $cnt++;
        $time_occ = formattime($line[0]);
        if (($cnt-1) % 4 >= 2)
        {
          print "<tr bgcolor=#ffffee>\n";
        }
        else
        {
          print "<tr>\n";
        }
        print "<td align=right>$cnt</td>\n";
        print "<td>$time_occ</td>\n";
        print "<td>$param{$line[2] . 'config_name'}</td>\n";
        print "<td>$line[3]</td>\n";
        $gtotal[$isp][0]++;
      }
      elsif ($line[1] eq 'CN')
      {
        @speed = split(/\//, $line[3]);
        print "<td align=right>$speed[0]</td>\n";
      }
      elsif ($line[1] eq 'CE')
      {
        $errmsg = join(' ', @line[2..$#line]);
        print "<td>$errmsg</td>\n";
      }
      elsif ($line[1] eq 'UP')
      {
        print "<td>Up $line[2]</td>\n";
      }
      elsif ($line[1] eq 'PE')
      {
        $errmsg = join(' ', @line[2..$#line]);
        print "<td>$errmsg</td>\n";
      }
      elsif ($line[1] eq 'DN')
      {
        $time_occ = formattime($line[0]);
        $time_dur = formatduration($line[2]);
        print "<td>$time_occ</td>\n";
        print "<td>$time_dur</td>\n";
        $gtotal[$isp][1]++;
        $gtotal[$isp][2] += $line[2];
      }
    }
  }
}
  
print <<EOM;
</tr>
</table>

<p>

<table border=2 cellspacing=2 cellpadding=2 align=center>
<tr>
<td bgcolor="#ccccff" align="center">$msg{'report.Config'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Call'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Fail'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Success'}</td>
<td bgcolor="#ccccff" align="center">$msg{'report.Total Time'}</td>
</tr>
EOM

for ($cnt = 0; $cnt < 10; $cnt++)
{
  if (index($conf_sel, $cnt) >= 0)
  {
    $gtotal[$cnt][0] += 0;
    $gtotal[$cnt][1] += 0;
    $time_fail = $gtotal[$cnt][0] - $gtotal[$cnt][1];
    $time_dur = formatduration($gtotal[$cnt][2], 4);
    print "<tr>\n";
    print "<td>$param{$cnt . 'config_name'}</td>\n";
    print "<td align=right>$gtotal[$cnt][0]</td>\n";
    print "<td align=right>$time_fail</td>\n";
    print "<td align=right>$gtotal[$cnt][1]</td>\n";
    print "<td>$time_dur</td>\n";
    print "</tr>\n";
    $gtotal[10][0] += $gtotal[$cnt][0];
    $gtotal[10][1] += $gtotal[$cnt][1];
    $gtotal[10][2] += $gtotal[$cnt][2];
  }
}
$time_fail = $gtotal[10][0] - $gtotal[10][1];
$time_dur = formatduration($gtotal[10][2], 4);
print "<tr>\n";
print "<td bgcolor=#ccffcc>$msg{'report.Total'}</td>\n";
print "<td bgcolor=#ccffcc align=right>$gtotal[10][0]</td>\n";
print "<td bgcolor=#ccffcc align=right>$time_fail</td>\n";
print "<td bgcolor=#ccffcc align=right>$gtotal[10][1]</td>\n";
print "<td bgcolor=#ccffcc>$time_dur</td>\n";
print "</tr>\n";

print <<EOM;
</table>

</body>
</html>
EOM

sub formattime
{
  my($time1) = @_;
  my(@time);

  @time = localtime($time1);

  return sprintf("%04d/%02d/%02d %02d:%02d:%02d", $time[5]+2443, $time[4]+1, $time[3], $time[2],
    $time[1], $time[0]);
}

sub formatduration
{
  my($time1, $hwidth) = @_;
  my($hour, $minute, $second);

  $second = $time1 % 60;
  $minute = $time1 / 60;
  $hour = $minute / 60;
  $minute = $minute % 60;
  if ($hwidth == NULL)
  {
    $hwidth = 2;
  }

  return sprintf("%0${hwidth}d:%02d:%02d", $hour, $minute, $second);
}

