#!/usr/bin/perl

# Internet Gateway Control Panel
# Copyright (c) 2542 (1999) by Atsawin Chowanakritsanakul

use CGI;

require 'getmsg.pl';

getmsg();

$conf = "/usr/lib/diald/conf/dialdcpl.conf";
$fifo = "/usr/lib/diald/diald.fifo";
$squid_conf_in = "/usr/local/squid/etc/squid.conf.in";
$squid_conf = "/usr/local/squid/etc/squid.conf";
$squid_reconfigure = "/usr/lib/diald/prog/squid_reconfigure";

$local_domain = "\." . qx('/bin/dnsdomainname');

$r = new CGI;
$conf_num = $r->param('conf');

open(TEXT, "$conf") or die $!;
@text = <TEXT>;
close(TEXT);

$section = 1000;
foreach $line (@text)
{
  chomp($line);
  if (substr($line, 0, 5) eq '[conf')
  {
    $section = substr($line, 5, 1);
  }
  else
  {
    ($key, $value) = split(/=/, $line, 2);
    if ($section < 1000)
    {
      $key = $section . $key;
    }
    $param{$key} = $value;
  }
}

$conf_act = $r->param('conf_num');

umask(0600);
open(TEXT, ">$conf") or die $!;
print TEXT "[global]\n";
print TEXT "active=$conf_act\n";
for ($section = 0; $section <= 9; $section++)
{
  $param{$section . 'config_name'} = "Config$section" if ($param{$section .
    'config_name'} eq '');
  $param{$section . 'serial_device'} = "/dev/modem" if ($param{$section .
    'serial_device'} eq '');
  $param{$section . 'serial_speed'} = "57600" if ($param{$section .
    'serial_speed'} eq '');
  $param{$section . 'modem_init'} = "AT &F H0" if ($param{$section .
    'modem_init'} eq '');
  print TEXT "[conf$section]\n";
  print TEXT "config_name=$param{$section . 'config_name'}\n";
  print TEXT "connection_mode=$param{$section . 'connection_mode'}\n";
  print TEXT "serial_device=$param{$section . 'serial_device'}\n";
  print TEXT "serial_speed=$param{$section . 'serial_speed'}\n";
  print TEXT "modem_init=$param{$section . 'modem_init'}\n";
  print TEXT "dial_prefix=$param{$section . 'dial_prefix'}\n";
  print TEXT "phone_number=$param{$section . 'phone_number'}\n";
  print TEXT "user_name=$param{$section . 'user_name'}\n";
  print TEXT "password=$param{$section . 'password'}\n";
  print TEXT "proxy1_addr=$param{$section . 'proxy1_addr'}\n";
  print TEXT "proxy1_port=$param{$section . 'proxy1_port'}\n";
  print TEXT "proxy1_type=$param{$section . 'proxy1_type'}\n";
  print TEXT "proxy2_addr=$param{$section . 'proxy2_addr'}\n";
  print TEXT "proxy2_port=$param{$section . 'proxy2_port'}\n";
  print TEXT "proxy2_type=$param{$section . 'proxy2_type'}\n";
  print TEXT "mail_addr=$param{$section . 'mail_addr'}\n";
}
close(TEXT);

open(TEXT, ">/etc/ppp/diald.conf") or die $!;
print TEXT "mode ppp\n";
print TEXT "connect \"/usr/lib/diald/connect.pl\"\n";
print TEXT "ip-up \"/usr/lib/diald/ip-up.pl\"\n";
print TEXT "ip-down \"/usr/lib/diald/ip-down.pl\"\n";
print TEXT "pppderror \"/usr/lib/diald/pppderror.pl\"\n";
print TEXT "device $param{$conf_act . 'serial_device'}\n";
print TEXT "speed $param{$conf_act . 'serial_speed'}\n";
print TEXT "modem\n";
print TEXT "lock\n";
print TEXT "crtscts\n";
print TEXT "dynamic\n";
print TEXT "local 192.168.255.1\n";
print TEXT "remote 192.168.255.2\n";
print TEXT "defaultroute\n";
print TEXT "redial-timeout 10\n";
print TEXT "fifo /usr/lib/diald/diald.fifo\n";
print TEXT "accounting-log /usr/lib/diald/diald.log\n";
print TEXT "include /usr/lib/diald/standard.filter\n";
if ($param{$conf_act . 'connection_mode'} eq 'manual')
{
  print TEXT "-demand\n";
  print TEXT "blocked\n";
}
close(TEXT);

open(TEXT, "$squid_conf_in") or die $!;
@text = <TEXT>;
close(TEXT);
open(TEXT, ">$squid_conf") or die $!;
print TEXT @text;
print TEXT "\n";
print TEXT "# Parent proxy\n";
if ($param{$conf_act . 'proxy1_addr'} ne "" && $param{$conf_act . 'proxy1_port'} ne "")
{
  if ($param{$conf_act . 'proxy1_type'} eq "squid")
  {
    print TEXT "cache_peer $param{$conf_act . 'proxy1_addr'} parent $param{$conf_act . 'proxy1_port'} 3130\n";
  }
  else
  {
    print TEXT "cache_peer $param{$conf_act . 'proxy1_addr'} parent $param{$conf_act . 'proxy1_port'} 7 no-query default\n";
  }
  print TEXT "cache_peer_domain $param{$conf_act . 'proxy1_addr'} !$local_domain\n";
}
if ($param{$conf_act . 'proxy2_addr'} ne "" && $param{$conf_act . 'proxy2_port'} ne "")
{
  if ($param{$conf_act . 'proxy2_type'} eq "squid")
  {
    print TEXT "cache_peer $param{$conf_act . 'proxy2_addr'} parent $param{$conf_act . 'proxy2_port'} 3130\n";
  }
  else
  {
    print TEXT "cache_peer $param{$conf_act . 'proxy2_addr'} parent $param{$conf_act . 'proxy2_port'} 7 no-query default\n";
  }
  print TEXT "cache_peer_domain $param{$conf_act . 'proxy2_addr'} !$local_domain\n";
}
close(TEXT);

open(FIFO, "> $fifo") or die $!;
print FIFO "reset\n";
close(FIFO);

system($squid_reconfigure);

print $r->header;

print <<EOM;
<html>
<head>
<title>$msg{'global.Internet Gateway Control Panel'} : $msg{'global.Main Menu'} : $msg{'global.Active Configuration Changed'}</title>
<link rel=stylesheet type="text/css" href="/gateway/default.css">
</head>
<body bgcolor=#ffffff text=#000000 link=#0000ff vlink=#0000ff alink=#ff0000>
<table border=0 cellspacing=0 cellpadding=2 width=100%>
<tr>
<td bgcolor=#99cccc width=100%>
<a href="/gateway/intro.html">$msg{'global.Internet Gateway Control Panel'}</a> :
<a href="/gateway/main.html">$msg{'global.Main Menu'}</a>
</td>
</tr>
<tr>
<td bgcolor=#ccffff width=100% align=center>
<font size=+3>$msg{'select.Active Configuration Changed'}</font>
</td>
</tr>
</table>
<p>

<table border=2 cellspacing=2 cellpadding=2 align=center>
<tr>
<td bgcolor=#ccffff align=right>
$msg{'select.Active Configuration'}</td>
<td bgcolor=#ffffcc>
$conf_act $param{$conf_act . 'config_name'}
</td>
</tr>
<tr>
<td bgcolor=#ccffcc align=center colspan=2>
<a href="/gateway/main.html">$msg{'global.Back to Main Menu'}</a>
</td>
</tr>
</table>

</body>
</html>
EOM

