#!/usr/bin/perl

# Internet Gateway Control Panel
# Copyright (c) 2542 (1999) by Atsawin Chowanakritsanakul

use CGI;

require 'getmsg.pl';

getmsg();

$fifo = "/usr/lib/diald/diald.fifo";
$stat = "/usr/lib/diald/diald.stat";
$lastdial = "/usr/lib/diald/lastdial.txt";

$r = new CGI;

if (!fork)
{
  select(undef, undef, undef, 0.05);   # Wait 50 ms

  open(FIFO, "> $fifo") or die $!;
  print FIFO "monitor 0x00000105 $stat\n";
  close(FIFO);

  exit(0);
}

open(STAT, "< $stat") or die $!;
do
{
  $text = <STAT>;
  $state1 = <STAT>;
  chomp($text);
} until ($text eq 'STATE');
do
{
  $text = <STAT>;
  $state2 = <STAT>;
  chomp($text);
} until ($text eq 'STATUS');
close(STAT);

open(TEXT, "< $lastdial") or die $!;
$phone = <TEXT>;
$result = <TEXT>;
$ip = <TEXT>;
$up_time = <TEXT>;
close(TEXT);

chomp($state1);
chomp($state2);
chomp($phone);
chomp($result);
chomp($ip);
chomp($up_time);
$speed = $result;
@speed = split(/[ \/]/, $speed);
$speed = $speed[2];
@up_time = gmtime(time()-$up_time);
$up_time[3] = $up_time[3]-1;
($local_ip, $tmp, $remote_ip) = split(/ /, $ip);
$reason = substr($result, 3, 255);

# HTTP protocol header
print $r->header;

print <<EOM;
<html>
<head>
<meta http-equiv="refresh" content="4">
<link rel=stylesheet type="text/css" href="/gateway/default.css">
</head>
<body bgcolor=#ffffff text=#000000 link=#0000ff vlink=#990099 alink=#ff0000>
<table border=2 cellspacing=2 cellpadding=2 align=center>
<tr>
<td bgcolor=#ccffff align=right>
$msg{'status.Connection'}</td>
<td bgcolor=#ffffcc>
$msg{'global.' . $state1}
</td>
EOM
if ($state1 eq 'CLOSE' || $state1 eq 'RETRY')
{
  print "<td bgcolor=#ccffff align=right>\n";
  print "$msg{'status.Reason'}</td>\n";
  print "<td bgcolor=#ffffcc>\n";
  if (substr($reason, 0, 7) eq 'CONNECT')
  {
    print "$msg{'status.Control'}\n";
  }
  else
  {
    print "$reason\n";
  }
  print "</td>\n";
}
if ($state1 eq 'UP' || $state1 eq 'START_LINK' || $state1 eq 'CONNECT')
{
  print "<td bgcolor=#ccffff align=right>\n";
  print "$msg{'status.Phone'}</td>\n";
  print "<td bgcolor=#ffffcc>\n";
  print "$phone\n";
  print "</td>\n";
}
if ($state1 eq 'UP' || $state1 eq 'START_LINK')
{
  print "<td bgcolor=#ccffff align=right>\n";
  print "$msg{'status.Speed'}</td>\n";
  print "<td bgcolor=#ffffcc>\n";
  print "$speed bps\n";
  print "</td>\n";
}
print "</tr>\n";
if ($state1 eq 'UP')
{
  print "<tr>\n";
  print "<td bgcolor=#ccffff align=right>\n";
  print "$msg{'status.Local IP'}</td>\n";
  print "<td bgcolor=#ffffcc>\n";
  print "$local_ip\n";
  print "</td>\n";
  print "<td bgcolor=#ccffff align=right>\n";
  print "$msg{'status.Remote IP'}</td>\n";
  print "<td bgcolor=#ffffcc>\n";
  print "$remote_ip\n";
  print "</td>\n";
  print "<td bgcolor=#ccffff align=right>\n";
  print "$msg{'status.Time'}</td>\n";
  print "<td bgcolor=#ffffcc>\n";
  print "$up_time[3] $msg{'global.Day'} $up_time[2] $msg{'global.Hour'} $up_time[1] $msg{'global.Minute'} $up_time[0] $msg{'global.Second'}\n";
  print "</td>\n";
  print "</tr>\n";
}
print "</table>\n";

print "</body>\n";
print "</html>\n";

