#!/usr/bin/perl

# Internet Gateway Control Panel
# Copyright (c) 2542 (1999) by Atsawin Chowanakritsanakul

$conf = "/usr/lib/diald/conf/dialdcpl.conf";
$count = "/usr/lib/diald/conf/count.conf";
$script = "/usr/lib/diald/connect.txt";
$lastdial = "/usr/lib/diald/lastdial.txt";
$history = "/usr/lib/diald/history.txt";
$log = "/usr/lib/diald/connect.log";

open(TEXT, "$conf") or die $!;
@text = <TEXT>;
close(TEXT);

$section = 1000;
foreach $line (@text)
{
  chomp($line);
  if (substr($line, 0, 5) eq '[conf')
  {
    $section = substr($line, 5, 1);
  }
  else
  {
    ($key, $value) = split(/=/, $line, 2);
    if ($section < 1000)
    {
      $key = $section . $key;
    }
    $param{$key} = $value;
  }
}
$conf_act = $param{'active'};

if (open(TEXT, "$count"))
{
  @phone_index = <TEXT>;
  close(TEXT);
}

for ($section = 0; $section <= $#phone_index; $section++)
{
  chomp($phone_index[$section]);
}
for ($section = $#phone_index+1; $section <= 9; $section++)
{
  $phone_index[$section] = 0;
}

$phone_index = $phone_index[$conf_act];

@phone_number = split(/ /, $param{$conf_act . 'phone_number'});
$phone_number = $phone_number[$phone_index];

$time_occ = time();

open(TEXT, ">$script") or die $!;
print TEXT "TIMEOUT 60\n";
print TEXT "REPORT CONNECT\n";
print TEXT "ABORT ERROR\n";
print TEXT "ABORT BUSY\n";
print TEXT "ABORT \"NO CARRIER\"\n";
print TEXT "ABORT \"NO DIALTONE\"\n";
print TEXT "ABORT \"NO DIAL TONE\"\n";
print TEXT "\"\" \"$param{$conf_act . 'modem_init'}\"\n";
print TEXT "OK \"atdt$param{$conf_act . 'dial_prefix'}$phone_number\"\n";
print TEXT "CONNECT\n";
close(TEXT);

open(TEXT, ">$lastdial") or die $!;
print TEXT "$phone_number\n";
close(TEXT);

open(TEXT, ">>$history") or die $!;
print TEXT "$time_occ DI $conf_act $phone_number\n";
close(TEXT);

$phone_index[$conf_act] = ($phone_index+1) % ($#phone_number+1);

open(TEXT, ">$count") or die $!;
for ($section = 0; $section <= 9; $section++)
{
  print TEXT "$phone_index[$section]\n";
}
close(TEXT);

umask(0600);
open(TEXT, ">/etc/ppp/pap-secrets") or die $!;
print TEXT "\"$param{$conf_act . 'user_name'}\"	\*	\"$param{$conf_act . 'password'}\"\n";
close(TEXT);

open(TEXT, ">/etc/ppp/options") or die $!;
print TEXT "noipdefault\n";
print TEXT "noauth\n";
print TEXT "debug\n";
print TEXT "passive\n";
print TEXT "asyncmap 0\n";
print TEXT "name \"$param{$conf_act . 'user_name'}\"\n";
if ($param{$conf_act . 'local_ip'} . $param{$conf_act . 'remote_ip'} ne '')
{
  if ($param{$conf_act . 'local_ip'} ne '')
  {
    print TEXT "$param{$conf_act . 'local_ip'}";
  }
  print TEXT ":";
  if ($param{$conf_act . 'remote_ip'} ne '')
  {
    print TEXT "$param{$conf_act . 'remote_ip'}";
  }
  print TEXT "\n";
}
close(TEXT);

unlink($log);
unlink('/usr/lib/diald/pppd.log');
system('/bin/killall -1 syslogd');

system("/usr/sbin/chat", "-v", "-f", $script, "-r", $log);
$exit_value = $? >> 8;

if ($exit_value == 0)
{
  $phone_index[$conf_act] = $phone_index;
  unlink("${count}.tmp") if (-e "${count}.tmp");
  rename($count, "${count}.tmp");
  open(TEXT, ">$count") or die $!;
  for ($section = 0; $section <= 9; $section++)
  {
    print TEXT "$phone_index[$section]\n";
  }
  close(TEXT);

  open(TEXT, "$log") or die $!;
  @text = <TEXT>;
  close(TEXT);

  chomp($text[1]);
  $connect = 'CN ' . substr($text[1], 23, 255);
}
elsif ($exit_value == 3)
{
  $connect = 'CE Time Out';
}
elsif ($exit_value == 4)
{
  $connect = 'CE Modem Error';
}
elsif ($exit_value == 5)
{
  $connect = 'CE Line Busy';
}
elsif ($exit_value == 6)
{
  $connect = 'CE No Carrier';
}
elsif ($exit_value == 7 or $exit_value == 8)
{
  $connect = 'CE No Dialtone';
}
else
{
  $connect = 'CE Unknown Error';
}

$time_occ = time();

open(TEXT, ">>$lastdial") or die $!;
print TEXT "$connect\n";
close(TEXT);

open(TEXT, ">>$history") or die $!;
print TEXT "$time_occ $connect\n";
close(TEXT);

exit($exit_value);

